/* DockElement.c generated by valac 0.26.1, the Vala compiler
 * generated from DockElement.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define PLANK_ITEMS_TYPE_ANIMATION (plank_items_animation_get_type ())

#define PLANK_ITEMS_TYPE_POPUP_BUTTON (plank_items_popup_button_get_type ())

#define PLANK_ITEMS_TYPE_DOCK_ELEMENT (plank_items_dock_element_get_type ())
#define PLANK_ITEMS_DOCK_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_ITEMS_TYPE_DOCK_ELEMENT, PlankItemsDockElement))
#define PLANK_ITEMS_DOCK_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_ITEMS_TYPE_DOCK_ELEMENT, PlankItemsDockElementClass))
#define PLANK_ITEMS_IS_DOCK_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_ITEMS_TYPE_DOCK_ELEMENT))
#define PLANK_ITEMS_IS_DOCK_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_ITEMS_TYPE_DOCK_ELEMENT))
#define PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_ITEMS_TYPE_DOCK_ELEMENT, PlankItemsDockElementClass))

typedef struct _PlankItemsDockElement PlankItemsDockElement;
typedef struct _PlankItemsDockElementClass PlankItemsDockElementClass;
typedef struct _PlankItemsDockElementPrivate PlankItemsDockElementPrivate;

#define PLANK_ITEMS_TYPE_DOCK_CONTAINER (plank_items_dock_container_get_type ())
#define PLANK_ITEMS_DOCK_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_ITEMS_TYPE_DOCK_CONTAINER, PlankItemsDockContainer))
#define PLANK_ITEMS_DOCK_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_ITEMS_TYPE_DOCK_CONTAINER, PlankItemsDockContainerClass))
#define PLANK_ITEMS_IS_DOCK_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_ITEMS_TYPE_DOCK_CONTAINER))
#define PLANK_ITEMS_IS_DOCK_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_ITEMS_TYPE_DOCK_CONTAINER))
#define PLANK_ITEMS_DOCK_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_ITEMS_TYPE_DOCK_CONTAINER, PlankItemsDockContainerClass))

typedef struct _PlankItemsDockContainer PlankItemsDockContainer;
typedef struct _PlankItemsDockContainerClass PlankItemsDockContainerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define PLANK_TYPE_DOCK_CONTROLLER (plank_dock_controller_get_type ())
#define PLANK_DOCK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_DOCK_CONTROLLER, PlankDockController))
#define PLANK_DOCK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_DOCK_CONTROLLER, PlankDockControllerClass))
#define PLANK_IS_DOCK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_DOCK_CONTROLLER))
#define PLANK_IS_DOCK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_DOCK_CONTROLLER))
#define PLANK_DOCK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_DOCK_CONTROLLER, PlankDockControllerClass))

typedef struct _PlankDockController PlankDockController;
typedef struct _PlankDockControllerClass PlankDockControllerClass;

typedef enum  {
	PLANK_ITEMS_ANIMATION_NONE,
	PLANK_ITEMS_ANIMATION_BOUNCE,
	PLANK_ITEMS_ANIMATION_DARKEN,
	PLANK_ITEMS_ANIMATION_LIGHTEN
} PlankItemsAnimation;

typedef enum  {
	PLANK_ITEMS_POPUP_BUTTON_NONE = 1 << 0,
	PLANK_ITEMS_POPUP_BUTTON_LEFT = 1 << 1,
	PLANK_ITEMS_POPUP_BUTTON_MIDDLE = 1 << 2,
	PLANK_ITEMS_POPUP_BUTTON_RIGHT = 1 << 3
} PlankItemsPopupButton;

struct _PlankItemsDockElement {
	GObject parent_instance;
	PlankItemsDockElementPrivate * priv;
};

struct _PlankItemsDockElementClass {
	GObjectClass parent_class;
	PlankItemsAnimation (*on_clicked) (PlankItemsDockElement* self, PlankItemsPopupButton button, GdkModifierType mod);
	PlankItemsAnimation (*on_hovered) (PlankItemsDockElement* self);
	PlankItemsAnimation (*on_scrolled) (PlankItemsDockElement* self, GdkScrollDirection direction, GdkModifierType mod);
	GeeArrayList* (*get_menu_items) (PlankItemsDockElement* self);
	gboolean (*can_be_removed) (PlankItemsDockElement* self);
	gboolean (*can_accept_drop) (PlankItemsDockElement* self, GeeArrayList* uris);
	gboolean (*accept_drop) (PlankItemsDockElement* self, GeeArrayList* uris);
	gchar* (*unique_id) (PlankItemsDockElement* self);
	void (*reset_buffers) (PlankItemsDockElement* self);
};

struct _PlankItemsDockElementPrivate {
	PlankItemsDockContainer* _Container;
	gchar* _Text;
	gboolean _IsAttached;
	gboolean _IsVisible;
	PlankItemsPopupButton _Button;
	PlankItemsAnimation _ClickedAnimation;
	PlankItemsAnimation _HoveredAnimation;
	PlankItemsAnimation _ScrolledAnimation;
	gint64 _AddTime;
	gint64 _RemoveTime;
	gint64 _LastClicked;
	gint64 _LastHovered;
	gint64 _LastScrolled;
	gint64 _LastUrgent;
	gint64 _LastActive;
	gint64 _LastMove;
};


static gpointer plank_items_dock_element_parent_class = NULL;

GType plank_items_animation_get_type (void) G_GNUC_CONST;
GType plank_items_popup_button_get_type (void) G_GNUC_CONST;
PlankItemsPopupButton plank_items_popup_button_from_event_button (GdkEventButton* event);
GType plank_items_dock_element_get_type (void) G_GNUC_CONST;
GType plank_items_dock_container_get_type (void) G_GNUC_CONST;
#define PLANK_ITEMS_DOCK_ELEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_ITEMS_TYPE_DOCK_ELEMENT, PlankItemsDockElementPrivate))
enum  {
	PLANK_ITEMS_DOCK_ELEMENT_DUMMY_PROPERTY,
	PLANK_ITEMS_DOCK_ELEMENT_CONTAINER,
	PLANK_ITEMS_DOCK_ELEMENT_TEXT,
	PLANK_ITEMS_DOCK_ELEMENT_IS_ATTACHED,
	PLANK_ITEMS_DOCK_ELEMENT_IS_VISIBLE,
	PLANK_ITEMS_DOCK_ELEMENT_BUTTON,
	PLANK_ITEMS_DOCK_ELEMENT_CLICKED_ANIMATION,
	PLANK_ITEMS_DOCK_ELEMENT_HOVERED_ANIMATION,
	PLANK_ITEMS_DOCK_ELEMENT_SCROLLED_ANIMATION,
	PLANK_ITEMS_DOCK_ELEMENT_ADD_TIME,
	PLANK_ITEMS_DOCK_ELEMENT_REMOVE_TIME,
	PLANK_ITEMS_DOCK_ELEMENT_LAST_CLICKED,
	PLANK_ITEMS_DOCK_ELEMENT_LAST_HOVERED,
	PLANK_ITEMS_DOCK_ELEMENT_LAST_SCROLLED,
	PLANK_ITEMS_DOCK_ELEMENT_LAST_URGENT,
	PLANK_ITEMS_DOCK_ELEMENT_LAST_ACTIVE,
	PLANK_ITEMS_DOCK_ELEMENT_LAST_MOVE
};
void plank_items_dock_element_clicked (PlankItemsDockElement* self, PlankItemsPopupButton button, GdkModifierType mod);
PlankItemsAnimation plank_items_dock_element_on_clicked (PlankItemsDockElement* self, PlankItemsPopupButton button, GdkModifierType mod);
void plank_items_dock_element_set_ClickedAnimation (PlankItemsDockElement* self, PlankItemsAnimation value);
void plank_items_dock_element_set_LastClicked (PlankItemsDockElement* self, gint64 value);
static PlankItemsAnimation plank_items_dock_element_real_on_clicked (PlankItemsDockElement* self, PlankItemsPopupButton button, GdkModifierType mod);
void plank_items_dock_element_hovered (PlankItemsDockElement* self);
PlankItemsAnimation plank_items_dock_element_on_hovered (PlankItemsDockElement* self);
void plank_items_dock_element_set_HoveredAnimation (PlankItemsDockElement* self, PlankItemsAnimation value);
void plank_items_dock_element_set_LastHovered (PlankItemsDockElement* self, gint64 value);
static PlankItemsAnimation plank_items_dock_element_real_on_hovered (PlankItemsDockElement* self);
void plank_items_dock_element_scrolled (PlankItemsDockElement* self, GdkScrollDirection direction, GdkModifierType mod);
PlankItemsAnimation plank_items_dock_element_on_scrolled (PlankItemsDockElement* self, GdkScrollDirection direction, GdkModifierType mod);
void plank_items_dock_element_set_ScrolledAnimation (PlankItemsDockElement* self, PlankItemsAnimation value);
static PlankItemsAnimation plank_items_dock_element_real_on_scrolled (PlankItemsDockElement* self, GdkScrollDirection direction, GdkModifierType mod);
void plank_items_dock_element_set_LastScrolled (PlankItemsDockElement* self, gint64 value);
GType plank_dock_controller_get_type (void) G_GNUC_CONST;
PlankDockController* plank_items_dock_element_get_dock (PlankItemsDockElement* self);
PlankItemsDockContainer* plank_items_dock_element_get_Container (PlankItemsDockElement* self);
GeeArrayList* plank_items_dock_element_get_menu_items (PlankItemsDockElement* self);
static GeeArrayList* plank_items_dock_element_real_get_menu_items (PlankItemsDockElement* self);
gboolean plank_items_dock_element_can_be_removed (PlankItemsDockElement* self);
static gboolean plank_items_dock_element_real_can_be_removed (PlankItemsDockElement* self);
gboolean plank_items_dock_element_can_accept_drop (PlankItemsDockElement* self, GeeArrayList* uris);
static gboolean plank_items_dock_element_real_can_accept_drop (PlankItemsDockElement* self, GeeArrayList* uris);
gboolean plank_items_dock_element_accept_drop (PlankItemsDockElement* self, GeeArrayList* uris);
static gboolean plank_items_dock_element_real_accept_drop (PlankItemsDockElement* self, GeeArrayList* uris);
gchar* plank_items_dock_element_unique_id (PlankItemsDockElement* self);
static gchar* plank_items_dock_element_real_unique_id (PlankItemsDockElement* self);
gchar* plank_items_dock_element_as_uri (PlankItemsDockElement* self);
void plank_items_dock_element_reset_buffers (PlankItemsDockElement* self);
static void plank_items_dock_element_real_reset_buffers (PlankItemsDockElement* self);
GtkMenuItem* plank_items_dock_element_create_menu_item (const gchar* title, const gchar* icon, gboolean force_show_icon);
GdkPixbuf* plank_drawing_drawing_service_load_icon (const gchar* names, gint width, gint height);
GtkMenuItem* plank_items_dock_element_create_menu_item_with_pixbuf (const gchar* title, GdkPixbuf* pixbuf, gboolean force_show_icon);
GdkPixbuf* plank_drawing_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height);
PlankItemsDockElement* plank_items_dock_element_construct (GType object_type);
void plank_items_dock_element_set_Container (PlankItemsDockElement* self, PlankItemsDockContainer* value);
const gchar* plank_items_dock_element_get_Text (PlankItemsDockElement* self);
void plank_items_dock_element_set_Text (PlankItemsDockElement* self, const gchar* value);
gboolean plank_items_dock_element_get_IsAttached (PlankItemsDockElement* self);
void plank_items_dock_element_set_IsAttached (PlankItemsDockElement* self, gboolean value);
gboolean plank_items_dock_element_get_IsVisible (PlankItemsDockElement* self);
void plank_items_dock_element_set_IsVisible (PlankItemsDockElement* self, gboolean value);
PlankItemsPopupButton plank_items_dock_element_get_Button (PlankItemsDockElement* self);
void plank_items_dock_element_set_Button (PlankItemsDockElement* self, PlankItemsPopupButton value);
PlankItemsAnimation plank_items_dock_element_get_ClickedAnimation (PlankItemsDockElement* self);
PlankItemsAnimation plank_items_dock_element_get_HoveredAnimation (PlankItemsDockElement* self);
PlankItemsAnimation plank_items_dock_element_get_ScrolledAnimation (PlankItemsDockElement* self);
gint64 plank_items_dock_element_get_AddTime (PlankItemsDockElement* self);
void plank_items_dock_element_set_AddTime (PlankItemsDockElement* self, gint64 value);
gint64 plank_items_dock_element_get_RemoveTime (PlankItemsDockElement* self);
void plank_items_dock_element_set_RemoveTime (PlankItemsDockElement* self, gint64 value);
gint64 plank_items_dock_element_get_LastClicked (PlankItemsDockElement* self);
gint64 plank_items_dock_element_get_LastHovered (PlankItemsDockElement* self);
gint64 plank_items_dock_element_get_LastScrolled (PlankItemsDockElement* self);
gint64 plank_items_dock_element_get_LastUrgent (PlankItemsDockElement* self);
void plank_items_dock_element_set_LastUrgent (PlankItemsDockElement* self, gint64 value);
gint64 plank_items_dock_element_get_LastActive (PlankItemsDockElement* self);
void plank_items_dock_element_set_LastActive (PlankItemsDockElement* self, gint64 value);
gint64 plank_items_dock_element_get_LastMove (PlankItemsDockElement* self);
void plank_items_dock_element_set_LastMove (PlankItemsDockElement* self, gint64 value);
static void plank_items_dock_element_finalize (GObject* obj);
static void _vala_plank_items_dock_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_plank_items_dock_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * What type of animation to perform when an item is or was interacted with.
 */
GType plank_items_animation_get_type (void) {
	static volatile gsize plank_items_animation_type_id__volatile = 0;
	if (g_once_init_enter (&plank_items_animation_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_ITEMS_ANIMATION_NONE, "PLANK_ITEMS_ANIMATION_NONE", "none"}, {PLANK_ITEMS_ANIMATION_BOUNCE, "PLANK_ITEMS_ANIMATION_BOUNCE", "bounce"}, {PLANK_ITEMS_ANIMATION_DARKEN, "PLANK_ITEMS_ANIMATION_DARKEN", "darken"}, {PLANK_ITEMS_ANIMATION_LIGHTEN, "PLANK_ITEMS_ANIMATION_LIGHTEN", "lighten"}, {0, NULL, NULL}};
		GType plank_items_animation_type_id;
		plank_items_animation_type_id = g_enum_register_static ("PlankItemsAnimation", values);
		g_once_init_leave (&plank_items_animation_type_id__volatile, plank_items_animation_type_id);
	}
	return plank_items_animation_type_id__volatile;
}


/**
 * Convenience method to map {@link Gdk.EventButton} to this enum.
 *
 * @param event the event to map
 * @return the PopupButton representation of the event
 */
PlankItemsPopupButton plank_items_popup_button_from_event_button (GdkEventButton* event) {
	PlankItemsPopupButton result = 0;
	GdkEventButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	g_return_val_if_fail (event != NULL, 0);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->button;
	switch (_tmp1_) {
		default:
		case GDK_BUTTON_PRIMARY:
		{
			result = PLANK_ITEMS_POPUP_BUTTON_LEFT;
			return result;
		}
		case GDK_BUTTON_MIDDLE:
		{
			result = PLANK_ITEMS_POPUP_BUTTON_MIDDLE;
			return result;
		}
		case GDK_BUTTON_SECONDARY:
		{
			result = PLANK_ITEMS_POPUP_BUTTON_RIGHT;
			return result;
		}
	}
}


/**
 * What mouse button pops up the context menu on an item.
 * Can be multiple buttons.
 */
GType plank_items_popup_button_get_type (void) {
	static volatile gsize plank_items_popup_button_type_id__volatile = 0;
	if (g_once_init_enter (&plank_items_popup_button_type_id__volatile)) {
		static const GFlagsValue values[] = {{PLANK_ITEMS_POPUP_BUTTON_NONE, "PLANK_ITEMS_POPUP_BUTTON_NONE", "none"}, {PLANK_ITEMS_POPUP_BUTTON_LEFT, "PLANK_ITEMS_POPUP_BUTTON_LEFT", "left"}, {PLANK_ITEMS_POPUP_BUTTON_MIDDLE, "PLANK_ITEMS_POPUP_BUTTON_MIDDLE", "middle"}, {PLANK_ITEMS_POPUP_BUTTON_RIGHT, "PLANK_ITEMS_POPUP_BUTTON_RIGHT", "right"}, {0, NULL, NULL}};
		GType plank_items_popup_button_type_id;
		plank_items_popup_button_type_id = g_flags_register_static ("PlankItemsPopupButton", values);
		g_once_init_leave (&plank_items_popup_button_type_id__volatile, plank_items_popup_button_type_id);
	}
	return plank_items_popup_button_type_id__volatile;
}


/**
 * Called when an item is clicked on.
 *
 * @param button the button clicked
 * @param mod the modifiers
 */
void plank_items_dock_element_clicked (PlankItemsDockElement* self, PlankItemsPopupButton button, GdkModifierType mod) {
	PlankItemsPopupButton _tmp0_ = 0;
	GdkModifierType _tmp1_ = 0;
	PlankItemsAnimation _tmp2_ = 0;
	gint64 _tmp3_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = button;
	_tmp1_ = mod;
	_tmp2_ = plank_items_dock_element_on_clicked (self, _tmp0_, _tmp1_);
	plank_items_dock_element_set_ClickedAnimation (self, _tmp2_);
	_tmp3_ = g_get_monotonic_time ();
	plank_items_dock_element_set_LastClicked (self, _tmp3_);
}


/**
 * Called when an item is clicked on.
 *
 * @param button the button clicked
 * @param mod the modifiers
 * @return which type of animation to trigger
 */
static PlankItemsAnimation plank_items_dock_element_real_on_clicked (PlankItemsDockElement* self, PlankItemsPopupButton button, GdkModifierType mod) {
	PlankItemsAnimation result = 0;
	result = PLANK_ITEMS_ANIMATION_NONE;
	return result;
}


PlankItemsAnimation plank_items_dock_element_on_clicked (PlankItemsDockElement* self, PlankItemsPopupButton button, GdkModifierType mod) {
	g_return_val_if_fail (self != NULL, 0);
	return PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS (self)->on_clicked (self, button, mod);
}


/**
 * Called when an item gets hovered.
 */
void plank_items_dock_element_hovered (PlankItemsDockElement* self) {
	PlankItemsAnimation _tmp0_ = 0;
	gint64 _tmp1_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = plank_items_dock_element_on_hovered (self);
	plank_items_dock_element_set_HoveredAnimation (self, _tmp0_);
	_tmp1_ = g_get_monotonic_time ();
	plank_items_dock_element_set_LastHovered (self, _tmp1_);
}


/**
 * Called when an item gets hovered.
 */
static PlankItemsAnimation plank_items_dock_element_real_on_hovered (PlankItemsDockElement* self) {
	PlankItemsAnimation result = 0;
	result = PLANK_ITEMS_ANIMATION_LIGHTEN;
	return result;
}


PlankItemsAnimation plank_items_dock_element_on_hovered (PlankItemsDockElement* self) {
	g_return_val_if_fail (self != NULL, 0);
	return PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS (self)->on_hovered (self);
}


/**
 * Called when an item is scrolled over.
 *
 * @param direction the scroll direction
 * @param mod the modifiers
 */
void plank_items_dock_element_scrolled (PlankItemsDockElement* self, GdkScrollDirection direction, GdkModifierType mod) {
	GdkScrollDirection _tmp0_ = 0;
	GdkModifierType _tmp1_ = 0;
	PlankItemsAnimation _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = direction;
	_tmp1_ = mod;
	_tmp2_ = plank_items_dock_element_on_scrolled (self, _tmp0_, _tmp1_);
	plank_items_dock_element_set_ScrolledAnimation (self, _tmp2_);
}


/**
 * Called when an item is scrolled over.
 *
 * @param direction the scroll direction
 * @param mod the modifiers
 * @return which type of animation to trigger
 */
static PlankItemsAnimation plank_items_dock_element_real_on_scrolled (PlankItemsDockElement* self, GdkScrollDirection direction, GdkModifierType mod) {
	PlankItemsAnimation result = 0;
	gint64 _tmp0_ = 0LL;
	_tmp0_ = g_get_monotonic_time ();
	plank_items_dock_element_set_LastScrolled (self, _tmp0_);
	result = PLANK_ITEMS_ANIMATION_NONE;
	return result;
}


PlankItemsAnimation plank_items_dock_element_on_scrolled (PlankItemsDockElement* self, GdkScrollDirection direction, GdkModifierType mod) {
	g_return_val_if_fail (self != NULL, 0);
	return PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS (self)->on_scrolled (self, direction, mod);
}


/**
 * Get the dock which this element is part of
 *
 * @return the dock-controller of this element, or null
 */
PlankDockController* plank_items_dock_element_get_dock (PlankItemsDockElement* self) {
	PlankDockController* result = NULL;
	PlankItemsDockContainer* container = NULL;
	PlankItemsDockContainer* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Container;
	container = _tmp0_;
	while (TRUE) {
		PlankItemsDockContainer* _tmp1_ = NULL;
		PlankItemsDockContainer* _tmp2_ = NULL;
		PlankItemsDockContainer* _tmp4_ = NULL;
		PlankItemsDockContainer* _tmp5_ = NULL;
		_tmp1_ = container;
		if (!(_tmp1_ != NULL)) {
			break;
		}
		_tmp2_ = container;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, PLANK_TYPE_DOCK_CONTROLLER)) {
			PlankItemsDockContainer* _tmp3_ = NULL;
			_tmp3_ = container;
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, PLANK_TYPE_DOCK_CONTROLLER, PlankDockController);
			return result;
		}
		_tmp4_ = container;
		_tmp5_ = ((PlankItemsDockElement*) _tmp4_)->priv->_Container;
		container = _tmp5_;
	}
	result = NULL;
	return result;
}


/**
 * Returns a list of the item's menu items.
 *
 * @return the item's menu items
 */
static GeeArrayList* plank_items_dock_element_real_get_menu_items (PlankItemsDockElement* self) {
	GeeArrayList* result = NULL;
	GeeArrayList* _tmp0_ = NULL;
	_tmp0_ = gee_array_list_new (gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	result = _tmp0_;
	return result;
}


GeeArrayList* plank_items_dock_element_get_menu_items (PlankItemsDockElement* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS (self)->get_menu_items (self);
}


/**
 * Returns if this item can be removed from the dock.
 *
 * @return if this item can be removed from the dock
 */
static gboolean plank_items_dock_element_real_can_be_removed (PlankItemsDockElement* self) {
	gboolean result = FALSE;
	result = TRUE;
	return result;
}


gboolean plank_items_dock_element_can_be_removed (PlankItemsDockElement* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS (self)->can_be_removed (self);
}


/**
 * Returns if the item accepts a drop of the given URIs.
 *
 * @param uris the URIs to check
 * @return if the item accepts a drop of the given URIs
 */
static gboolean plank_items_dock_element_real_can_accept_drop (PlankItemsDockElement* self, GeeArrayList* uris) {
	gboolean result = FALSE;
	g_return_val_if_fail (uris != NULL, FALSE);
	result = FALSE;
	return result;
}


gboolean plank_items_dock_element_can_accept_drop (PlankItemsDockElement* self, GeeArrayList* uris) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS (self)->can_accept_drop (self, uris);
}


/**
 * Accepts a drop of the given URIs.
 *
 * @param uris the URIs to accept
 * @return if the item accepted a drop of the given URIs
 */
static gboolean plank_items_dock_element_real_accept_drop (PlankItemsDockElement* self, GeeArrayList* uris) {
	gboolean result = FALSE;
	g_return_val_if_fail (uris != NULL, FALSE);
	result = FALSE;
	return result;
}


gboolean plank_items_dock_element_accept_drop (PlankItemsDockElement* self, GeeArrayList* uris) {
	g_return_val_if_fail (self != NULL, FALSE);
	return PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS (self)->accept_drop (self, uris);
}


/**
 * Returns a unique ID for this dock item.
 *
 * @return a unique ID for this dock element
 */
static gchar* plank_items_dock_element_real_unique_id (PlankItemsDockElement* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	_tmp0_ = g_strdup_printf ("dockelement%d", (gint) self);
	result = _tmp0_;
	return result;
}


gchar* plank_items_dock_element_unique_id (PlankItemsDockElement* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS (self)->unique_id (self);
}


/**
 * Returns a unique URI for this dock element.
 *
 * @return a unique URI for this dock element
 */
gchar* plank_items_dock_element_as_uri (PlankItemsDockElement* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = plank_items_dock_element_unique_id (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat ("plank://", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}


/**
 * Resets the buffers for this element.
 */
static void plank_items_dock_element_real_reset_buffers (PlankItemsDockElement* self) {
	g_critical ("Type `%s' does not implement abstract method `plank_items_dock_element_reset_buffers'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void plank_items_dock_element_reset_buffers (PlankItemsDockElement* self) {
	g_return_if_fail (self != NULL);
	PLANK_ITEMS_DOCK_ELEMENT_GET_CLASS (self)->reset_buffers (self);
}


/**
 * Creates a new menu item.
 *
 * @param title the title of the menu item
 * @param icon the icon of the menu item
 * @param force_show_icon whether to force showing the icon
 * @return the new menu item
 */
GtkMenuItem* plank_items_dock_element_create_menu_item (const gchar* title, const gchar* icon, gboolean force_show_icon) {
	GtkMenuItem* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GtkImageMenuItem* item = NULL;
	const gchar* _tmp7_ = NULL;
	GtkImageMenuItem* _tmp8_ = NULL;
	GtkImageMenuItem* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GdkPixbuf* _tmp13_ = NULL;
	GdkPixbuf* _tmp14_ = NULL;
	GtkImage* _tmp15_ = NULL;
	GtkImage* _tmp16_ = NULL;
	gboolean _tmp17_ = FALSE;
	g_return_val_if_fail (title != NULL, NULL);
	_tmp1_ = icon;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = icon;
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
	}
	if (_tmp0_) {
		const gchar* _tmp3_ = NULL;
		GtkMenuItem* _tmp4_ = NULL;
		_tmp3_ = title;
		_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp3_);
		g_object_ref_sink (_tmp4_);
		result = _tmp4_;
		return result;
	}
	gtk_icon_size_lookup (GTK_ICON_SIZE_MENU, &_tmp5_, &_tmp6_);
	width = _tmp5_;
	height = _tmp6_;
	_tmp7_ = title;
	_tmp8_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_mnemonic (_tmp7_);
	g_object_ref_sink (_tmp8_);
	item = _tmp8_;
	_tmp9_ = item;
	_tmp10_ = icon;
	_tmp11_ = width;
	_tmp12_ = height;
	_tmp13_ = plank_drawing_drawing_service_load_icon (_tmp10_, _tmp11_, _tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp14_);
	g_object_ref_sink (_tmp15_);
	_tmp16_ = _tmp15_;
	gtk_image_menu_item_set_image (_tmp9_, (GtkWidget*) _tmp16_);
	_g_object_unref0 (_tmp16_);
	_g_object_unref0 (_tmp14_);
	_tmp17_ = force_show_icon;
	if (_tmp17_) {
		GtkImageMenuItem* _tmp18_ = NULL;
		_tmp18_ = item;
		gtk_image_menu_item_set_always_show_image (_tmp18_, TRUE);
	}
	result = (GtkMenuItem*) item;
	return result;
}


/**
 * Creates a new menu item.
 *
 * @param title the title of the menu item
 * @param pixbuf the icon of the menu item
 * @param force_show_icon whether to force showing the icon
 * @return the new menu item
 */
GtkMenuItem* plank_items_dock_element_create_menu_item_with_pixbuf (const gchar* title, GdkPixbuf* pixbuf, gboolean force_show_icon) {
	GtkMenuItem* result = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_ = 0;
	GdkPixbuf* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GtkImageMenuItem* item = NULL;
	const gchar* _tmp15_ = NULL;
	GtkImageMenuItem* _tmp16_ = NULL;
	GtkImageMenuItem* _tmp17_ = NULL;
	GdkPixbuf* _tmp18_ = NULL;
	GtkImage* _tmp19_ = NULL;
	GtkImage* _tmp20_ = NULL;
	gboolean _tmp21_ = FALSE;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (pixbuf != NULL, NULL);
	gtk_icon_size_lookup (GTK_ICON_SIZE_MENU, &_tmp0_, &_tmp1_);
	width = _tmp0_;
	height = _tmp1_;
	_tmp3_ = width;
	_tmp4_ = pixbuf;
	_tmp5_ = gdk_pixbuf_get_width (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp3_ != _tmp6_) {
		_tmp2_ = TRUE;
	} else {
		gint _tmp7_ = 0;
		GdkPixbuf* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		_tmp7_ = height;
		_tmp8_ = pixbuf;
		_tmp9_ = gdk_pixbuf_get_height (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp2_ = _tmp7_ != _tmp10_;
	}
	if (_tmp2_) {
		GdkPixbuf* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		GdkPixbuf* _tmp14_ = NULL;
		_tmp11_ = pixbuf;
		_tmp12_ = width;
		_tmp13_ = height;
		_tmp14_ = plank_drawing_drawing_service_ar_scale (_tmp11_, _tmp12_, _tmp13_);
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp14_;
	}
	_tmp15_ = title;
	_tmp16_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_mnemonic (_tmp15_);
	g_object_ref_sink (_tmp16_);
	item = _tmp16_;
	_tmp17_ = item;
	_tmp18_ = pixbuf;
	_tmp19_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp18_);
	g_object_ref_sink (_tmp19_);
	_tmp20_ = _tmp19_;
	gtk_image_menu_item_set_image (_tmp17_, (GtkWidget*) _tmp20_);
	_g_object_unref0 (_tmp20_);
	_tmp21_ = force_show_icon;
	if (_tmp21_) {
		GtkImageMenuItem* _tmp22_ = NULL;
		_tmp22_ = item;
		gtk_image_menu_item_set_always_show_image (_tmp22_, TRUE);
	}
	result = (GtkMenuItem*) item;
	_g_object_unref0 (pixbuf);
	return result;
}


PlankItemsDockElement* plank_items_dock_element_construct (GType object_type) {
	PlankItemsDockElement * self = NULL;
	self = (PlankItemsDockElement*) g_object_new (object_type, NULL);
	return self;
}


PlankItemsDockContainer* plank_items_dock_element_get_Container (PlankItemsDockElement* self) {
	PlankItemsDockContainer* result;
	PlankItemsDockContainer* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Container;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void plank_items_dock_element_set_Container (PlankItemsDockElement* self, PlankItemsDockContainer* value) {
	PlankItemsDockContainer* _tmp0_ = NULL;
	PlankItemsDockContainer* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_Container);
	self->priv->_Container = _tmp1_;
	g_object_notify ((GObject *) self, "Container");
}


const gchar* plank_items_dock_element_get_Text (PlankItemsDockElement* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Text;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_Text (PlankItemsDockElement* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_Text);
	self->priv->_Text = _tmp1_;
	g_object_notify ((GObject *) self, "Text");
}


gboolean plank_items_dock_element_get_IsAttached (PlankItemsDockElement* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_IsAttached;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_IsAttached (PlankItemsDockElement* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_IsAttached = _tmp0_;
	g_object_notify ((GObject *) self, "IsAttached");
}


gboolean plank_items_dock_element_get_IsVisible (PlankItemsDockElement* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_IsVisible;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_IsVisible (PlankItemsDockElement* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_IsVisible = _tmp0_;
	g_object_notify ((GObject *) self, "IsVisible");
}


PlankItemsPopupButton plank_items_dock_element_get_Button (PlankItemsDockElement* self) {
	PlankItemsPopupButton result;
	PlankItemsPopupButton _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Button;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_Button (PlankItemsDockElement* self, PlankItemsPopupButton value) {
	PlankItemsPopupButton _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_Button = _tmp0_;
	g_object_notify ((GObject *) self, "Button");
}


PlankItemsAnimation plank_items_dock_element_get_ClickedAnimation (PlankItemsDockElement* self) {
	PlankItemsAnimation result;
	PlankItemsAnimation _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_ClickedAnimation;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_ClickedAnimation (PlankItemsDockElement* self, PlankItemsAnimation value) {
	PlankItemsAnimation _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_ClickedAnimation = _tmp0_;
	g_object_notify ((GObject *) self, "ClickedAnimation");
}


PlankItemsAnimation plank_items_dock_element_get_HoveredAnimation (PlankItemsDockElement* self) {
	PlankItemsAnimation result;
	PlankItemsAnimation _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_HoveredAnimation;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_HoveredAnimation (PlankItemsDockElement* self, PlankItemsAnimation value) {
	PlankItemsAnimation _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_HoveredAnimation = _tmp0_;
	g_object_notify ((GObject *) self, "HoveredAnimation");
}


PlankItemsAnimation plank_items_dock_element_get_ScrolledAnimation (PlankItemsDockElement* self) {
	PlankItemsAnimation result;
	PlankItemsAnimation _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_ScrolledAnimation;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_ScrolledAnimation (PlankItemsDockElement* self, PlankItemsAnimation value) {
	PlankItemsAnimation _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_ScrolledAnimation = _tmp0_;
	g_object_notify ((GObject *) self, "ScrolledAnimation");
}


gint64 plank_items_dock_element_get_AddTime (PlankItemsDockElement* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_AddTime;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_AddTime (PlankItemsDockElement* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_AddTime = _tmp0_;
	g_object_notify ((GObject *) self, "AddTime");
}


gint64 plank_items_dock_element_get_RemoveTime (PlankItemsDockElement* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_RemoveTime;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_RemoveTime (PlankItemsDockElement* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_RemoveTime = _tmp0_;
	g_object_notify ((GObject *) self, "RemoveTime");
}


gint64 plank_items_dock_element_get_LastClicked (PlankItemsDockElement* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastClicked;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_LastClicked (PlankItemsDockElement* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_LastClicked = _tmp0_;
	g_object_notify ((GObject *) self, "LastClicked");
}


gint64 plank_items_dock_element_get_LastHovered (PlankItemsDockElement* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastHovered;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_LastHovered (PlankItemsDockElement* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_LastHovered = _tmp0_;
	g_object_notify ((GObject *) self, "LastHovered");
}


gint64 plank_items_dock_element_get_LastScrolled (PlankItemsDockElement* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastScrolled;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_LastScrolled (PlankItemsDockElement* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_LastScrolled = _tmp0_;
	g_object_notify ((GObject *) self, "LastScrolled");
}


gint64 plank_items_dock_element_get_LastUrgent (PlankItemsDockElement* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastUrgent;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_LastUrgent (PlankItemsDockElement* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_LastUrgent = _tmp0_;
	g_object_notify ((GObject *) self, "LastUrgent");
}


gint64 plank_items_dock_element_get_LastActive (PlankItemsDockElement* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastActive;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_LastActive (PlankItemsDockElement* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_LastActive = _tmp0_;
	g_object_notify ((GObject *) self, "LastActive");
}


gint64 plank_items_dock_element_get_LastMove (PlankItemsDockElement* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_LastMove;
	result = _tmp0_;
	return result;
}


void plank_items_dock_element_set_LastMove (PlankItemsDockElement* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_LastMove = _tmp0_;
	g_object_notify ((GObject *) self, "LastMove");
}


static void plank_items_dock_element_class_init (PlankItemsDockElementClass * klass) {
	plank_items_dock_element_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankItemsDockElementPrivate));
	((PlankItemsDockElementClass *) klass)->on_clicked = plank_items_dock_element_real_on_clicked;
	((PlankItemsDockElementClass *) klass)->on_hovered = plank_items_dock_element_real_on_hovered;
	((PlankItemsDockElementClass *) klass)->on_scrolled = plank_items_dock_element_real_on_scrolled;
	((PlankItemsDockElementClass *) klass)->get_menu_items = plank_items_dock_element_real_get_menu_items;
	((PlankItemsDockElementClass *) klass)->can_be_removed = plank_items_dock_element_real_can_be_removed;
	((PlankItemsDockElementClass *) klass)->can_accept_drop = plank_items_dock_element_real_can_accept_drop;
	((PlankItemsDockElementClass *) klass)->accept_drop = plank_items_dock_element_real_accept_drop;
	((PlankItemsDockElementClass *) klass)->unique_id = plank_items_dock_element_real_unique_id;
	((PlankItemsDockElementClass *) klass)->reset_buffers = plank_items_dock_element_real_reset_buffers;
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_items_dock_element_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_items_dock_element_set_property;
	G_OBJECT_CLASS (klass)->finalize = plank_items_dock_element_finalize;
	/**
	 * The dock element's container which it is added too (if any).
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_CONTAINER, g_param_spec_object ("Container", "Container", "Container", PLANK_ITEMS_TYPE_DOCK_CONTAINER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The dock item's text.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_TEXT, g_param_spec_string ("Text", "Text", "Text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Whether the item is currently hidden on the dock.
	 * If TRUE it will be drawn and does consume space.
	 * If FALSE it will not be drawn and does not consume space.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_IS_ATTACHED, g_param_spec_boolean ("IsAttached", "IsAttached", "IsAttached", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Whether the item is currently visible on the dock.
	 * If TRUE it will be drawn and does consume space.
	 * If FALSE it will not be drawn and does consume space.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_IS_VISIBLE, g_param_spec_boolean ("IsVisible", "IsVisible", "IsVisible", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The buttons this item shows popup menus for.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_BUTTON, g_param_spec_flags ("Button", "Button", "Button", PLANK_ITEMS_TYPE_POPUP_BUTTON, PLANK_ITEMS_POPUP_BUTTON_RIGHT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The animation to show for the item's last click event.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_CLICKED_ANIMATION, g_param_spec_enum ("ClickedAnimation", "ClickedAnimation", "ClickedAnimation", PLANK_ITEMS_TYPE_ANIMATION, PLANK_ITEMS_ANIMATION_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The animation to show for the item's last hover event.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_HOVERED_ANIMATION, g_param_spec_enum ("HoveredAnimation", "HoveredAnimation", "HoveredAnimation", PLANK_ITEMS_TYPE_ANIMATION, PLANK_ITEMS_ANIMATION_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The animation to show for the item's last scroll event.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_SCROLLED_ANIMATION, g_param_spec_enum ("ScrolledAnimation", "ScrolledAnimation", "ScrolledAnimation", PLANK_ITEMS_TYPE_ANIMATION, PLANK_ITEMS_ANIMATION_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The time the item was added to the dock.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_ADD_TIME, g_param_spec_int64 ("AddTime", "AddTime", "AddTime", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The time the item was removed from the dock.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_REMOVE_TIME, g_param_spec_int64 ("RemoveTime", "RemoveTime", "RemoveTime", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item was clicked.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_LAST_CLICKED, g_param_spec_int64 ("LastClicked", "LastClicked", "LastClicked", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item was hovered.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_LAST_HOVERED, g_param_spec_int64 ("LastHovered", "LastHovered", "LastHovered", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item was scrolled.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_LAST_SCROLLED, g_param_spec_int64 ("LastScrolled", "LastScrolled", "LastScrolled", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item changed its urgent status.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_LAST_URGENT, g_param_spec_int64 ("LastUrgent", "LastUrgent", "LastUrgent", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item changed its active status.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_LAST_ACTIVE, g_param_spec_int64 ("LastActive", "LastActive", "LastActive", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * The last time the item changed its position.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_ITEMS_DOCK_ELEMENT_LAST_MOVE, g_param_spec_int64 ("LastMove", "LastMove", "LastMove", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Signal fired when the dock element needs redrawn.
	 */
	g_signal_new ("needs_redraw", PLANK_ITEMS_TYPE_DOCK_ELEMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void plank_items_dock_element_instance_init (PlankItemsDockElement * self) {
	gchar* _tmp0_ = NULL;
	self->priv = PLANK_ITEMS_DOCK_ELEMENT_GET_PRIVATE (self);
	self->priv->_Container = NULL;
	_tmp0_ = g_strdup ("");
	self->priv->_Text = _tmp0_;
	self->priv->_IsAttached = TRUE;
	self->priv->_IsVisible = TRUE;
	self->priv->_Button = PLANK_ITEMS_POPUP_BUTTON_RIGHT;
	self->priv->_ClickedAnimation = PLANK_ITEMS_ANIMATION_NONE;
	self->priv->_HoveredAnimation = PLANK_ITEMS_ANIMATION_NONE;
	self->priv->_ScrolledAnimation = PLANK_ITEMS_ANIMATION_NONE;
}


static void plank_items_dock_element_finalize (GObject* obj) {
	PlankItemsDockElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_ITEMS_TYPE_DOCK_ELEMENT, PlankItemsDockElement);
	_g_object_unref0 (self->priv->_Container);
	_g_free0 (self->priv->_Text);
	G_OBJECT_CLASS (plank_items_dock_element_parent_class)->finalize (obj);
}


/**
 * The base class for all dock elements.
 */
GType plank_items_dock_element_get_type (void) {
	static volatile gsize plank_items_dock_element_type_id__volatile = 0;
	if (g_once_init_enter (&plank_items_dock_element_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankItemsDockElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_items_dock_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankItemsDockElement), 0, (GInstanceInitFunc) plank_items_dock_element_instance_init, NULL };
		GType plank_items_dock_element_type_id;
		plank_items_dock_element_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankItemsDockElement", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&plank_items_dock_element_type_id__volatile, plank_items_dock_element_type_id);
	}
	return plank_items_dock_element_type_id__volatile;
}


static void _vala_plank_items_dock_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PlankItemsDockElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_ITEMS_TYPE_DOCK_ELEMENT, PlankItemsDockElement);
	switch (property_id) {
		case PLANK_ITEMS_DOCK_ELEMENT_CONTAINER:
		g_value_set_object (value, plank_items_dock_element_get_Container (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_TEXT:
		g_value_set_string (value, plank_items_dock_element_get_Text (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_IS_ATTACHED:
		g_value_set_boolean (value, plank_items_dock_element_get_IsAttached (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_IS_VISIBLE:
		g_value_set_boolean (value, plank_items_dock_element_get_IsVisible (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_BUTTON:
		g_value_set_flags (value, plank_items_dock_element_get_Button (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_CLICKED_ANIMATION:
		g_value_set_enum (value, plank_items_dock_element_get_ClickedAnimation (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_HOVERED_ANIMATION:
		g_value_set_enum (value, plank_items_dock_element_get_HoveredAnimation (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_SCROLLED_ANIMATION:
		g_value_set_enum (value, plank_items_dock_element_get_ScrolledAnimation (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_ADD_TIME:
		g_value_set_int64 (value, plank_items_dock_element_get_AddTime (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_REMOVE_TIME:
		g_value_set_int64 (value, plank_items_dock_element_get_RemoveTime (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_CLICKED:
		g_value_set_int64 (value, plank_items_dock_element_get_LastClicked (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_HOVERED:
		g_value_set_int64 (value, plank_items_dock_element_get_LastHovered (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_SCROLLED:
		g_value_set_int64 (value, plank_items_dock_element_get_LastScrolled (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_URGENT:
		g_value_set_int64 (value, plank_items_dock_element_get_LastUrgent (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_ACTIVE:
		g_value_set_int64 (value, plank_items_dock_element_get_LastActive (self));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_MOVE:
		g_value_set_int64 (value, plank_items_dock_element_get_LastMove (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_plank_items_dock_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PlankItemsDockElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_ITEMS_TYPE_DOCK_ELEMENT, PlankItemsDockElement);
	switch (property_id) {
		case PLANK_ITEMS_DOCK_ELEMENT_CONTAINER:
		plank_items_dock_element_set_Container (self, g_value_get_object (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_TEXT:
		plank_items_dock_element_set_Text (self, g_value_get_string (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_IS_ATTACHED:
		plank_items_dock_element_set_IsAttached (self, g_value_get_boolean (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_IS_VISIBLE:
		plank_items_dock_element_set_IsVisible (self, g_value_get_boolean (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_BUTTON:
		plank_items_dock_element_set_Button (self, g_value_get_flags (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_CLICKED_ANIMATION:
		plank_items_dock_element_set_ClickedAnimation (self, g_value_get_enum (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_HOVERED_ANIMATION:
		plank_items_dock_element_set_HoveredAnimation (self, g_value_get_enum (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_SCROLLED_ANIMATION:
		plank_items_dock_element_set_ScrolledAnimation (self, g_value_get_enum (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_ADD_TIME:
		plank_items_dock_element_set_AddTime (self, g_value_get_int64 (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_REMOVE_TIME:
		plank_items_dock_element_set_RemoveTime (self, g_value_get_int64 (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_CLICKED:
		plank_items_dock_element_set_LastClicked (self, g_value_get_int64 (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_HOVERED:
		plank_items_dock_element_set_LastHovered (self, g_value_get_int64 (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_SCROLLED:
		plank_items_dock_element_set_LastScrolled (self, g_value_get_int64 (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_URGENT:
		plank_items_dock_element_set_LastUrgent (self, g_value_get_int64 (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_ACTIVE:
		plank_items_dock_element_set_LastActive (self, g_value_get_int64 (value));
		break;
		case PLANK_ITEMS_DOCK_ELEMENT_LAST_MOVE:
		plank_items_dock_element_set_LastMove (self, g_value_get_int64 (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



