/* HoverWindow.c generated by valac 0.26.1, the Vala compiler
 * generated from HoverWindow.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define PLANK_WIDGETS_TYPE_HOVER_WINDOW (plank_widgets_hover_window_get_type ())
#define PLANK_WIDGETS_HOVER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_WIDGETS_TYPE_HOVER_WINDOW, PlankWidgetsHoverWindow))
#define PLANK_WIDGETS_HOVER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_WIDGETS_TYPE_HOVER_WINDOW, PlankWidgetsHoverWindowClass))
#define PLANK_WIDGETS_IS_HOVER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_WIDGETS_TYPE_HOVER_WINDOW))
#define PLANK_WIDGETS_IS_HOVER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_WIDGETS_TYPE_HOVER_WINDOW))
#define PLANK_WIDGETS_HOVER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_WIDGETS_TYPE_HOVER_WINDOW, PlankWidgetsHoverWindowClass))

typedef struct _PlankWidgetsHoverWindow PlankWidgetsHoverWindow;
typedef struct _PlankWidgetsHoverWindowClass PlankWidgetsHoverWindowClass;
typedef struct _PlankWidgetsHoverWindowPrivate PlankWidgetsHoverWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _PlankWidgetsHoverWindow {
	GtkWindow parent_instance;
	PlankWidgetsHoverWindowPrivate * priv;
};

struct _PlankWidgetsHoverWindowClass {
	GtkWindowClass parent_class;
};

struct _PlankWidgetsHoverWindowPrivate {
	GtkBox* box;
	GtkLabel* label;
};


static gpointer plank_widgets_hover_window_parent_class = NULL;

GType plank_widgets_hover_window_get_type (void) G_GNUC_CONST;
#define PLANK_WIDGETS_HOVER_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_WIDGETS_TYPE_HOVER_WINDOW, PlankWidgetsHoverWindowPrivate))
enum  {
	PLANK_WIDGETS_HOVER_WINDOW_DUMMY_PROPERTY
};
#define PLANK_WIDGETS_HOVER_WINDOW_PADDING 10
PlankWidgetsHoverWindow* plank_widgets_hover_window_new (void);
PlankWidgetsHoverWindow* plank_widgets_hover_window_construct (GType object_type);
void plank_widgets_hover_window_show_at (PlankWidgetsHoverWindow* self, gint x, gint y, GtkPositionType position);
void plank_widgets_hover_window_set_text (PlankWidgetsHoverWindow* self, const gchar* text);
static gboolean plank_widgets_hover_window_real_draw (GtkWidget* base, cairo_t* cr);
static GObject * plank_widgets_hover_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void plank_widgets_hover_window_finalize (GObject* obj);


PlankWidgetsHoverWindow* plank_widgets_hover_window_construct (GType object_type) {
	PlankWidgetsHoverWindow * self = NULL;
	self = (PlankWidgetsHoverWindow*) g_object_new (object_type, "type", GTK_WINDOW_POPUP, "type-hint", GDK_WINDOW_TYPE_HINT_TOOLTIP, NULL);
	return self;
}


PlankWidgetsHoverWindow* plank_widgets_hover_window_new (void) {
	return plank_widgets_hover_window_construct (PLANK_WIDGETS_TYPE_HOVER_WINDOW);
}


/**
 * Shows and centers the window according to the x/y location specified
 * while accounting the dock's position.
 *
 * @param x the x location
 * @param y the y location
 * @param position the dock's position
 */
void plank_widgets_hover_window_show_at (PlankWidgetsHoverWindow* self, gint x, gint y, GtkPositionType position) {
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_ = NULL;
	GdkRectangle monitor = {0};
	GdkScreen* _tmp1_ = NULL;
	GdkScreen* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GdkRectangle _tmp6_ = {0};
	gint width = 0;
	gint _tmp7_ = 0;
	gint height = 0;
	gint _tmp8_ = 0;
	GtkPositionType _tmp9_ = 0;
	GdkRectangle _tmp24_ = {0};
	gint _tmp25_ = 0;
	gint _tmp26_ = 0;
	GdkRectangle _tmp27_ = {0};
	gint _tmp28_ = 0;
	GdkRectangle _tmp29_ = {0};
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	GdkRectangle _tmp34_ = {0};
	gint _tmp35_ = 0;
	gint _tmp36_ = 0;
	GdkRectangle _tmp37_ = {0};
	gint _tmp38_ = 0;
	GdkRectangle _tmp39_ = {0};
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	gint _tmp44_ = 0;
	gint _tmp45_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_window_get_screen ((GtkWindow*) self);
	screen = _tmp0_;
	_tmp1_ = screen;
	_tmp2_ = screen;
	_tmp3_ = x;
	_tmp4_ = y;
	_tmp5_ = gdk_screen_get_monitor_at_point (_tmp2_, _tmp3_, _tmp4_);
	gdk_screen_get_monitor_geometry (_tmp1_, _tmp5_, &_tmp6_);
	monitor = _tmp6_;
	gtk_widget_show ((GtkWidget*) self);
	_tmp7_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp7_;
	_tmp8_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp8_;
	_tmp9_ = position;
	switch (_tmp9_) {
		case GTK_POS_BOTTOM:
		{
			gint _tmp10_ = 0;
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			_tmp10_ = x;
			_tmp11_ = width;
			x = _tmp10_ - (_tmp11_ / 2);
			_tmp12_ = y;
			_tmp13_ = height;
			y = (_tmp12_ - _tmp13_) - PLANK_WIDGETS_HOVER_WINDOW_PADDING;
			break;
		}
		case GTK_POS_TOP:
		{
			gint _tmp14_ = 0;
			gint _tmp15_ = 0;
			gint _tmp16_ = 0;
			_tmp14_ = x;
			_tmp15_ = width;
			x = _tmp14_ - (_tmp15_ / 2);
			_tmp16_ = y;
			y = _tmp16_ + PLANK_WIDGETS_HOVER_WINDOW_PADDING;
			break;
		}
		case GTK_POS_LEFT:
		{
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			gint _tmp19_ = 0;
			_tmp17_ = x;
			x = _tmp17_ + PLANK_WIDGETS_HOVER_WINDOW_PADDING;
			_tmp18_ = y;
			_tmp19_ = height;
			y = _tmp18_ - (_tmp19_ / 2);
			break;
		}
		case GTK_POS_RIGHT:
		{
			gint _tmp20_ = 0;
			gint _tmp21_ = 0;
			gint _tmp22_ = 0;
			gint _tmp23_ = 0;
			_tmp20_ = x;
			_tmp21_ = width;
			x = (_tmp20_ - _tmp21_) - PLANK_WIDGETS_HOVER_WINDOW_PADDING;
			_tmp22_ = y;
			_tmp23_ = height;
			y = _tmp22_ - (_tmp23_ / 2);
			break;
		}
		default:
		break;
	}
	_tmp24_ = monitor;
	_tmp25_ = _tmp24_.x;
	_tmp26_ = x;
	_tmp27_ = monitor;
	_tmp28_ = _tmp27_.x;
	_tmp29_ = monitor;
	_tmp30_ = _tmp29_.width;
	_tmp31_ = width;
	_tmp32_ = MIN (_tmp26_, (_tmp28_ + _tmp30_) - _tmp31_);
	_tmp33_ = MAX (_tmp25_, _tmp32_);
	x = _tmp33_;
	_tmp34_ = monitor;
	_tmp35_ = _tmp34_.y;
	_tmp36_ = y;
	_tmp37_ = monitor;
	_tmp38_ = _tmp37_.y;
	_tmp39_ = monitor;
	_tmp40_ = _tmp39_.height;
	_tmp41_ = height;
	_tmp42_ = MIN (_tmp36_, (_tmp38_ + _tmp40_) - _tmp41_);
	_tmp43_ = MAX (_tmp35_, _tmp42_);
	y = _tmp43_;
	_tmp44_ = x;
	_tmp45_ = y;
	gtk_window_move ((GtkWindow*) self, _tmp44_, _tmp45_);
}


/**
 * Set the tooltip-text to show
 *
 * @param text the text to show
 */
void plank_widgets_hover_window_set_text (PlankWidgetsHoverWindow* self, const gchar* text) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->label;
	_tmp1_ = text;
	gtk_label_set_text (_tmp0_, _tmp1_);
	_tmp2_ = text;
	if (_tmp2_ != NULL) {
		GtkLabel* _tmp3_ = NULL;
		_tmp3_ = self->priv->label;
		gtk_widget_show ((GtkWidget*) _tmp3_);
	} else {
		GtkLabel* _tmp4_ = NULL;
		_tmp4_ = self->priv->label;
		gtk_widget_hide ((GtkWidget*) _tmp4_);
	}
}


/**
 * {@inheritDoc}
 */
static gboolean plank_widgets_hover_window_real_draw (GtkWidget* base, cairo_t* cr) {
	PlankWidgetsHoverWindow * self;
	gboolean result = FALSE;
	gint width = 0;
	gint _tmp0_ = 0;
	gint height = 0;
	gint _tmp1_ = 0;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	cairo_t* _tmp33_ = NULL;
	gboolean _tmp34_ = FALSE;
	self = (PlankWidgetsHoverWindow*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp0_;
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp1_;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
	context = _tmp2_;
	_tmp3_ = gtk_widget_is_composited ((GtkWidget*) self);
	if (_tmp3_) {
		cairo_t* _tmp4_ = NULL;
		cairo_t* _tmp5_ = NULL;
		cairo_t* _tmp6_ = NULL;
		cairo_t* _tmp7_ = NULL;
		GtkStyleContext* _tmp8_ = NULL;
		cairo_t* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		GtkStyleContext* _tmp12_ = NULL;
		cairo_t* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		_tmp4_ = cr;
		cairo_save (_tmp4_);
		_tmp5_ = cr;
		cairo_set_operator (_tmp5_, CAIRO_OPERATOR_CLEAR);
		_tmp6_ = cr;
		cairo_paint (_tmp6_);
		_tmp7_ = cr;
		cairo_restore (_tmp7_);
		gtk_widget_shape_combine_region ((GtkWidget*) self, NULL);
		_tmp8_ = context;
		_tmp9_ = cr;
		_tmp10_ = width;
		_tmp11_ = height;
		gtk_render_background (_tmp8_, _tmp9_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp10_, (gdouble) _tmp11_);
		_tmp12_ = context;
		_tmp13_ = cr;
		_tmp14_ = width;
		_tmp15_ = height;
		gtk_render_frame (_tmp12_, _tmp13_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp14_, (gdouble) _tmp15_);
	} else {
		cairo_surface_t* surface = NULL;
		GdkWindow* _tmp16_ = NULL;
		gint _tmp17_ = 0;
		gint _tmp18_ = 0;
		cairo_surface_t* _tmp19_ = NULL;
		cairo_t* compat_cr = NULL;
		cairo_surface_t* _tmp20_ = NULL;
		cairo_t* _tmp21_ = NULL;
		GtkStyleContext* _tmp22_ = NULL;
		cairo_t* _tmp23_ = NULL;
		gint _tmp24_ = 0;
		gint _tmp25_ = 0;
		GtkStyleContext* _tmp26_ = NULL;
		cairo_t* _tmp27_ = NULL;
		gint _tmp28_ = 0;
		gint _tmp29_ = 0;
		cairo_region_t* region = NULL;
		cairo_surface_t* _tmp30_ = NULL;
		cairo_region_t* _tmp31_ = NULL;
		cairo_region_t* _tmp32_ = NULL;
		_tmp16_ = gtk_widget_get_window ((GtkWidget*) self);
		_tmp17_ = width;
		_tmp18_ = height;
		_tmp19_ = gdk_window_create_similar_surface (_tmp16_, CAIRO_CONTENT_COLOR_ALPHA, _tmp17_, _tmp18_);
		surface = _tmp19_;
		_tmp20_ = surface;
		_tmp21_ = cairo_create (_tmp20_);
		compat_cr = _tmp21_;
		_tmp22_ = context;
		_tmp23_ = compat_cr;
		_tmp24_ = width;
		_tmp25_ = height;
		gtk_render_background (_tmp22_, _tmp23_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp24_, (gdouble) _tmp25_);
		_tmp26_ = context;
		_tmp27_ = compat_cr;
		_tmp28_ = width;
		_tmp29_ = height;
		gtk_render_frame (_tmp26_, _tmp27_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp28_, (gdouble) _tmp29_);
		_tmp30_ = surface;
		_tmp31_ = gdk_cairo_region_create_from_surface (_tmp30_);
		region = _tmp31_;
		_tmp32_ = region;
		gtk_widget_shape_combine_region ((GtkWidget*) self, _tmp32_);
		_cairo_region_destroy0 (region);
		_cairo_destroy0 (compat_cr);
		_cairo_surface_destroy0 (surface);
	}
	_tmp33_ = cr;
	_tmp34_ = GTK_WIDGET_CLASS (plank_widgets_hover_window_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp33_);
	result = _tmp34_;
	return result;
}


static GObject * plank_widgets_hover_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PlankWidgetsHoverWindow * self;
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_ = NULL;
	GdkVisual* _tmp1_ = NULL;
	GdkScreen* _tmp2_ = NULL;
	GdkVisual* _tmp3_ = NULL;
	GtkStyleContext* _tmp6_ = NULL;
	GtkBox* _tmp7_ = NULL;
	GtkBox* _tmp8_ = NULL;
	GtkBox* _tmp9_ = NULL;
	GtkBox* _tmp10_ = NULL;
	GtkBox* _tmp11_ = NULL;
	GtkBox* _tmp12_ = NULL;
	GtkBox* _tmp13_ = NULL;
	GtkLabel* _tmp14_ = NULL;
	GtkLabel* _tmp15_ = NULL;
	GtkBox* _tmp16_ = NULL;
	GtkLabel* _tmp17_ = NULL;
	parent_class = G_OBJECT_CLASS (plank_widgets_hover_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_WIDGETS_TYPE_HOVER_WINDOW, PlankWidgetsHoverWindow);
	gtk_widget_set_app_paintable ((GtkWidget*) self, TRUE);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	_tmp0_ = gtk_window_get_screen ((GtkWindow*) self);
	screen = _tmp0_;
	_tmp2_ = screen;
	_tmp3_ = gdk_screen_get_rgba_visual (_tmp2_);
	_tmp1_ = _tmp3_;
	if (_tmp1_ == NULL) {
		GdkScreen* _tmp4_ = NULL;
		GdkVisual* _tmp5_ = NULL;
		_tmp4_ = screen;
		_tmp5_ = gdk_screen_get_system_visual (_tmp4_);
		_tmp1_ = _tmp5_;
	}
	gtk_widget_set_visual ((GtkWidget*) self, _tmp1_);
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp6_, GTK_STYLE_CLASS_TOOLTIP);
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->box);
	self->priv->box = _tmp7_;
	_tmp8_ = self->priv->box;
	gtk_widget_set_margin_left ((GtkWidget*) _tmp8_, 6);
	_tmp9_ = self->priv->box;
	gtk_widget_set_margin_right ((GtkWidget*) _tmp9_, 6);
	_tmp10_ = self->priv->box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp10_, 6);
	_tmp11_ = self->priv->box;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp11_, 6);
	_tmp12_ = self->priv->box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp12_);
	_tmp13_ = self->priv->box;
	gtk_widget_show ((GtkWidget*) _tmp13_);
	_tmp14_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->label);
	self->priv->label = _tmp14_;
	_tmp15_ = self->priv->label;
	gtk_label_set_line_wrap (_tmp15_, TRUE);
	_tmp16_ = self->priv->box;
	_tmp17_ = self->priv->label;
	gtk_box_pack_start (_tmp16_, (GtkWidget*) _tmp17_, FALSE, FALSE, (guint) 0);
	return obj;
}


static void plank_widgets_hover_window_class_init (PlankWidgetsHoverWindowClass * klass) {
	plank_widgets_hover_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankWidgetsHoverWindowPrivate));
	((GtkWidgetClass *) klass)->draw = plank_widgets_hover_window_real_draw;
	G_OBJECT_CLASS (klass)->constructor = plank_widgets_hover_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_widgets_hover_window_finalize;
}


static void plank_widgets_hover_window_instance_init (PlankWidgetsHoverWindow * self) {
	self->priv = PLANK_WIDGETS_HOVER_WINDOW_GET_PRIVATE (self);
}


static void plank_widgets_hover_window_finalize (GObject* obj) {
	PlankWidgetsHoverWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_WIDGETS_TYPE_HOVER_WINDOW, PlankWidgetsHoverWindow);
	_g_object_unref0 (self->priv->box);
	_g_object_unref0 (self->priv->label);
	G_OBJECT_CLASS (plank_widgets_hover_window_parent_class)->finalize (obj);
}


/**
 * A hover window that shows labels for dock items.
 * This window floats outside (but near) the dock.
 */
GType plank_widgets_hover_window_get_type (void) {
	static volatile gsize plank_widgets_hover_window_type_id__volatile = 0;
	if (g_once_init_enter (&plank_widgets_hover_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankWidgetsHoverWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_widgets_hover_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankWidgetsHoverWindow), 0, (GInstanceInitFunc) plank_widgets_hover_window_instance_init, NULL };
		GType plank_widgets_hover_window_type_id;
		plank_widgets_hover_window_type_id = g_type_register_static (gtk_window_get_type (), "PlankWidgetsHoverWindow", &g_define_type_info, 0);
		g_once_init_leave (&plank_widgets_hover_window_type_id__volatile, plank_widgets_hover_window_type_id);
	}
	return plank_widgets_hover_window_type_id__volatile;
}



